#!/bin/bash
#
# Egyszer script MSS m25 dokumentumok teljes trlsre.
# Hvs: $0 els trlend ID, utols trlend ID (elhagyva csak egyet trl)
# Nincs hibakezels!
# kovacs.zoltan@mimoza.hu 2006-10-30

BACKUPPATH="/tmp"		# XML tartalom abszolt mentsi tvonala
#BACKUPPATH=""			# ha res, a ments letiltva

# MySQL belltsok
MYSQL_DBASE=""			# Adatbzis neve
MYSQL_USER=""			# Felhasznl neve
MYSQL_PASS=""			# Jelsz
MYSQL_CMD="mysql -u $MYSQL_USER --password=$MYSQL_PASS -D $MYSQL_DBASE -e"

# zenetek
MSG_NOTFOUND="Document not found:"
MSG_RMV_WBACKUP="Removed with backup:"
MSG_RMV_WOBACKUP="Removed without backup:"
MSG_USAGE="Usage: $0 first_m25_content.id_content value [last_m25_content.id_content value]"

# Legalbb az els paramternek lteznie kell!
first=${1:-0}; shift
last=${1:-$first}; shift
if [ $first -eq 0 ]; then echo "$MSG_USAGE" >&2; exit 1; fi
# Biztos, ami biztos...
if [ $first -gt $last ]; then echo "$MSG_USAGE" >&2; exit 1; fi

# Tblk zrolsa
$MYSQL_CMD 'LOCK TABLES m25_column__content WRITE, m25_content__cart WRITE, m25_content__keyword WRITE, m25_contentsearch WRITE, m25_content__contentstate WRITE, m25_content__user WRITE, m25_value WRITE;'
# Vgig a dokumentumokon
for (( id=first; id <= last; id++))
do
    # Rovatols megszntetse
    $MYSQL_CMD 'DELETE FROM m25_column__content WHERE id_content='$id
    # Kosrbl kivtel
    $MYSQL_CMD 'DELETE FROM m25_content__cart WHERE id_content='$id
    # Kulcssz hozzrendelsek trlse
    $MYSQL_CMD 'DELETE FROM m25_content__keyword WHERE id_content='$id
    # Full text search kivonat trlse
    $MYSQL_CMD 'DELETE FROM m25_contentsearch WHERE id_content='$id
    # Naplbejegyzsek trlse
    $MYSQL_CMD 'DELETE FROM m25_content__contentstate WHERE id_content='$id
    # Jogosultsgok visszavonsa
    $MYSQL_CMD 'DELETE FROM m25_content__user WHERE id_content='$id
    # Adattbla bejegyzsek megszntetse
    $MYSQL_CMD 'DELETE FROM m25_value WHERE id_content='$id
    # XML opcionlis mentse 
    if [ -z "`$MYSQL_CMD 'SELECT id_content FROM m25_content WHERE id_content='$id`" ]; then 
	# Nincs mit menteni
        echo "$MSG_NOTFOUND $id" >&2
    else
	if [ -d "$BACKUPPATH" ]; then 
	    # Mentssel
	    $MYSQL_CMD "SELECT content FROM m25_content WHERE id_content=$id INTO DUMPFILE '$BACKUPPATH/$id.xml'" 
	    echo "$MSG_RMV_WBACKUP $BACKUPPATH/$id.xml"
        else
	    # Ments nlkl
	    echo "$MSG_RMV_WOBACKUP $id"
	fi
    fi
    # Dokumentum megszntetse
    $MYSQL_CMD 'DELETE FROM m25_content WHERE id_content='$id
done
# Zrols feloldsa
$MYSQL_CMD 'UNLOCK TABLES;'

# That's all, folks!
