#!/bin/bash
#
# Egyszer script XML dokumentumok MSS m25 modultartalomknt betltsre.
# Nincs hibakezels!
# kovacs.zoltan@mimoza.hu 2006-10-24

# Forrs dokumentumok abszolt(!) knyvtra
SOURCEPATH="/var/home/webadmin/install.gvh/toload"	

# MSS belltsok
MSS_DOMAIN=""			# Domain szma
MSS_USER=""			# Tulajdonos felhasznl
MSS_GROUP=""			# Szerkeszt csoport(ok) - space delimited
MSS_STATUS="2"			# 2: szerkeszts alatt, 3: vglegestve

# MySQL belltsok
MYSQL_DBASE=""			# Adatbzis neve
MYSQL_USER=""			# Felhasznl neve
MYSQL_PASS=""			# Jelsz
MYSQL_CMD="mysql -u $MYSQL_USER --password=$MYSQL_PASS -D $MYSQL_DBASE -e"

# Egyb belltsok

SEARCHLIMIT=10			# Legalbb ennyi karakteres mez  kell ahhoz,
				# hogy szerepeljen a full text search tblban

# zenetek
MSG_ABORTED="Aborted!"
MSG_CONFIRM="Do you want to load all XML documents from $SOURCEPATH (y/n)?"
MSG_LOADING="Loading"

# Biztos, ami biztos...
read -s -n1 -p "$MSG_CONFIRM"; echo
if [ "$REPLY" != "y" -a "$REPLY" != "Y" ]; then 
    echo "$MSG_ABORTED" 
    exit 1
fi

# Tblk zrolsa
$MYSQL_CMD 'LOCK TABLES m25_content WRITE, m25_content__contentstate WRITE, m25_content__user WRITE;'

# Vgig a forrs dokumentumknyvtron

ls -1 $SOURCEPATH/*.xml | while read file    
do

#   Egy dokumentum bettele az m25_content tblba
    displayname=`cat $file | grep '<content' | sed "s/^.*displayname=\"\([^\"]*\)\".*$/\1/"`
    # Csak semmitmond cmeknl kell!
    displayname="$displayname ("`basename $file`")"
    $MYSQL_CMD "INSERT INTO m25_content (id_domain, displayname, content, id_base, encoding) VALUES ('$MSS_DOMAIN', '$displayname', LOAD_FILE(\"$file\"), 'main.dtd', 'ISO-8859-2');" 
    MSS_DOCID=`$MYSQL_CMD 'SELECT id_content FROM m25_content ORDER BY id_content DESC LIMIT 1;' | sed "s/id_content//"`

    echo $MSG_LOADING $file id_content = $MSS_DOCID

#   A dokumentum jvhagysnak belltsa
    $MYSQL_CMD "INSERT INTO m25_content__contentstate (id_content, id_contentstate, id_user, changetime, last) VALUES ('$MSS_DOCID', '$MSS_STATUS', '$MSS_USER', now(), '1');"

#   Jogosultsgok deleglsa 
    for editor in $MSS_GROUP
    do
	$MYSQL_CMD "INSERT INTO m25_content__user (id_content, id_user) VALUES ('$MSS_DOCID', '$editor');"
    done

#   Szabad szavas keress tbla feltltse

    cat $file | grep '<text_' | while read line
    do
	value="`echo $line | sed "s/^.*>\(.*\)<.*$/\1/"`"
	# Biztos, ami biztos - az idzjeleket kivesszk
	value=${value//"'"/}
	value=${value//'"'/}
	value=${value//'`'/}
	# nknyes hatr: $SEARCHLIMIT-nl rvidebb  tartalommal nem foglalkozunk
	if [[ ${#value} -ge $SEARCHLIMIT ]]; then
	    # Sztvlaszts element szerint - csak text_plain s text_rich
	    if [ ! -z "`echo $line | grep '<text_plain'`" ]; then
		type="text_plain"
		relevance="75"
		$MYSQL_CMD "INSERT INTO m25_contentsearch (id_content, id_domain, type, relevance, value) VALUES ('$MSS_DOCID', '$MSS_DOMAIN', '$type', '$relevance', '$value')"
	    elif [ ! -z "`echo $line | grep '<text_rich'`" ]; then
		type="text_rich"
		relevance="50"
		$MYSQL_CMD "INSERT INTO m25_contentsearch (id_content, id_domain, type, relevance, value) VALUES ('$MSS_DOCID', '$MSS_DOMAIN', '$type', '$relevance', '$value')"
	    fi
	fi
    done

#   Adattbla rtkek betltse
    cat $file | grep '<data_' | while read property
    do
	valuename=`echo "$property" | sed "s/.*[^_]name=\"\([^\"]*\).*$/\1/"`
	if   [[ "$property" = '<'data_char* ]]; then 
	    elementname='data_character'
	    vchar=`echo "$property" | sed "s/.*[^_]value=\"\([^\"]*\).*$/\1/"`
	    $MYSQL_CMD "INSERT INTO m25_value (id_content, elementname, valuename, vchar)  VALUES ('$MSS_DOCID', '$elementname', '$valuename', '$vchar');"
	elif [[ "$property" = '<'data_date* ]]; then 
	    elementname='data_date'
	    vdate=`echo "$property" | sed "s/.*[^_]value=\"\([^\"]*\).*$/\1/"`
	    $MYSQL_CMD "INSERT INTO m25_value (id_content, elementname, valuename, vdate)  VALUES ('$MSS_DOCID', '$elementname', '$valuename', '$vdate');"
	elif [[ "$property" = '<'data_enum* ]]; then 
	    elementname='data_enum'
	    vchar=`echo "$property" | sed "s/.*[^_]value=\"\([^\"]*\).*$/\1/"`
	    $MYSQL_CMD "INSERT INTO m25_value (id_content, elementname, valuename, vchar)  VALUES ('$MSS_DOCID', '$elementname', '$valuename', '$vchar');"
	elif [[ "$property" = '<'data_num*  ]]; then 
	    elementname='data_num'
	    vfloat=`echo "$property" | sed "s/.*[^_]value=\"\([^\"]*\).*$/\1/"`
	    $MYSQL_CMD "INSERT INTO m25_value (id_content, elementname, valuename, vfloat) VALUES ('$MSS_DOCID', '$elementname', '$valuename', '$vfloat');"
	fi
    done
done

# Zrols feloldsa
$MYSQL_CMD 'UNLOCK TABLES;'

# That's all, folks!
