#!/bin/bash
#
# Nagyon egyszer script feltlttt m25 dokumentum XML-ek elksztsre
# az m25_load.sh szmra. Egy paramtert vr, a feltlttt dokumentumokat
# tartalmaz knyvtr relatv elrsi tjt. Hibakezels nincs!
#
# kovacs.zoltan@mimoza.hu 2006-10-26

RESULTPATH="toload"
SOURCEPATH=${1:-'upload'}

# Ha van magyar s angol nyelv dokumentum is (NNNNh.xml s NNNNe.xml),
# azokat NNNN.xml nven a clknyvtrban sszefzi, figyelemmel az XML
# validitsra. Ha a dokumentum egynyelv, azonos nven viszi t..
# Minden esetben kiszedi a <?xml s <!DOCTYPE sorokat, ezek zavarjk az MSS-t.
# Megadja a Linux "other's read" jogot (MySQL LOAD_FILE() szmra.

ls -1 $SOURCEPATH/*.xml | while read file
do
    filenumber=`basename $file | sed "s/\(h\|e\)\.xml//"`
    # Kt nyelv-e a dokumentum?
    if [ -f $SOURCEPATH/$filenumber'h.xml' -a -f $SOURCEPATH/$filenumber'e.xml' ]; then
	echo "Merging $SOURCEPATH/$filenumber""h.xml and $SOURCEPATH/$filenumber""e.xml to $RESULTPATH/$filenumber.xml"
	# Kiszedjk a </content><content>-et s a <?xml valamint <!DOCTYPE sorokat
	cat $SOURCEPATH/$filenumber'h.xml' |\
	    grep -i -m 1 '<content ' >$RESULTPATH/$filenumber'.xml'
	cat $SOURCEPATH/$filenumber'h.xml' $SOURCEPATH/$filenumber'e.xml' |\
	    grep -iv '<content ' |\
	    grep -iv '</content>' |\
	    grep -vi --regexp='\(<?xml\)\|\(<!DOCTYPE\)' >>$RESULTPATH/$filenumber'.xml'
	    echo '</content>' >>$RESULTPATH/$filenumber'.xml'
	# a Linux "other's read" jog megadsa (MySQL LOAD_FILE() szmra)
	chmod o+r $RESULTPATH/$filenumber'.xml'
    # Egy nyelv dokumentum kezelse
    else
	echo "Copying $file to $RESULTPATH/"`basename $file`
	# Kiszedjk a <?xml s <!DOCTYPE sorokat
	cat $file | grep -vi --regexp='\(<?xml\)\|\(<!DOCTYPE\)' >$RESULTPATH/`basename $file`
	# a Linux "other's read" jog megadsa (MySQL LOAD_FILE() szmra)
	chmod o+r $RESULTPATH/`basename $file`
    fi
done
