#!/bin/bash
#
# Egyszer script MSS m25 dokumentumok _xx attributumainak trlsre.
# Az alhzssal kezdd attributumok az XML editornak szl belltsok,
# KIVVE a nem #FIXED attributumokat.
# Lehetsges gyorsteszt: cat m25_dtd | grep " _" | grep -iv "fixed" | sort -u  
# Kivtelek jelenleg: _col, _row,
# _bigfile_name, _bigfile_size, _bigfile_size_x, _bigfile_size_y,
# _file_name, _file_size, _file_size_x, _file_size_y,
# _fileimage_name, _fileimage_size, _fileimage_size_x, _fileimage_size_y
# Trlsk DTD vltoztats utn lehet szksges. A kvetkez szerkesztskor 
# ezeket az attributumokat  az editor visszarja  a dokumentumba.
# Az tmeneti llomnyok takartsa miatt root-knt rdemes futtatni.
#
# Nincs hibakezels!
# kovacs.zoltan@mimoza.hu 2006-12-18

BACKUPPATH="/tmp"               # XML tartalom abszolt mentsi tvonala
				# mysqld-nek ide rnia kell!
# MySQL belltsok
MYSQL_DBASE=""			# Adatbzis neve
MYSQL_USER=""			# Felhasznl neve
MYSQL_PASS=""			# Jelsz
MYSQL_CMD="mysql -u $MYSQL_USER --password=$MYSQL_PASS -D $MYSQL_DBASE -e"

# zenetek
MSG_ABORTED="Aborted!"
MSG_CONFIRM="Do you want to remove underscore atts from $MYSQL_DBASE (y/n)?"

# Biztos, ami biztos...
read -s -n1 -p "$MSG_CONFIRM"; echo
if [ "$REPLY" != "y" -a "$REPLY" != "Y" ]; then
    echo "$MSG_ABORTED"
    exit 1
fi

# Vgig a dokumentumokon
last=`$MYSQL_CMD 'SELECT id_content FROM m25_content ORDER BY id_content DESC LIMIT 1;' | sed "s/id_content//"`
for (( id=1; id <= last; id++))
do
    # Esetleges tmeneti llomnyok trlse
    if [ -e $BACKUPPATH/$id.xml ]; then rm $BACKUPPATH/$id.xml; fi
    if [ -e $BACKUPPATH/$id.new ]; then rm $BACKUPPATH/$id.xml; fi
    # Content tbla zrolsa
    $MYSQL_CMD 'LOCK TABLES m25_content WRITE;'
    # Content mentse tmeneti llomnyba
    $MYSQL_CMD "SELECT content FROM m25_content WHERE id_content=$id INTO DUMPFILE '$BACKUPPATH/$id.xml'"
    # res tartalom mellzse
    if [ ! -z "`cat $BACKUPPATH/$id.xml`" ]; then
        # Transzformcinl eldoband minden _xx="x" attributum KIVVE a felsoroltakat
	cat $BACKUPPATH/$id.xml | \
	sed "s/\(_\(col\|row\|bigfile_name\|bigfile_size\|bigfile_size_x\|bigfile_size_y\|file_name\|file_size\|file_size_x\|file_size_y\|fileimage_name\|fileimage_size\|fileimage_size_x\|fileimage_size_y\)=\"[^\"]*\"\)/_\1/g" | \
	sed "s/ _[^_][^=]*=\"[^\"]*\"//g" | \
	sed "s/_\(_\(col\|row\|bigfile_name\|bigfile_size\|bigfile_size_x\|bigfile_size_y\|file_name\|file_size\|file_size_x\|file_size_y\|fileimage_name\|fileimage_size\|fileimage_size_x\|fileimage_size_y\)=\"[^\"]*\"\)/\1/g" >$BACKUPPATH/$id.new
	# Content visszatltse tmeneti llomnybl
	chmod o+r $BACKUPPATH/$id.new
	$MYSQL_CMD "UPDATE m25_content SET content=LOAD_FILE('$BACKUPPATH/$id.new') WHERE id_content=$id;"
    fi
    # Zrols feloldsa
    $MYSQL_CMD 'UNLOCK TABLES;'
    # Takarts
    if [ -e $BACKUPPATH/$id.xml ]; then rm $BACKUPPATH/$id.xml; fi
    if [ -e $BACKUPPATH/$id.new ]; then rm $BACKUPPATH/$id.new; fi
done
