#!/bin/bash
#
# Simple script to remove GSS document preview HTML files.
# Run as cronjob, from cron.d practically.
# Usage: $0 GSS_name
# kovacs.zoltan@mimoza.hu 2005-06-15

APACHEADMIN="webadmin"                                  # Linux user for web administration
APACHEADMINGROUP="webadmin"                             # Linux group for web administration
APACHEDOCROOT="/var/www"                                # Public web documentroot
EXIT_ERR="1"                                            # Exit code on error
EXIT_SUCC="0"                                           # Exit code on success
FIND="/usr/bin/find"					# find command call
OLDTIME=1440						# Last access minutes ago to declare as old file
RM="/bin/rm"						# rm command call
TEMPFILEMASK="temp_*_temp.html"				# Temporary file name template

# Messages

MSG_DELETED="Deleted:"
MSG_MISSING="Missing file or directory: "
MSG_USAGE="Usage: $0 GSS_name\n\n"

# Get command-line parameters
# GSS name is mandatory and validated
                                                                                                                        
GSSNAME=$1; shift
if [ -z "$GSSNAME" ]; then echo -ne "$MSG_USAGE" >&2; exit $EXIT_ERR; fi
if [ ! -d $APACHEDOCROOT/$GSSNAME ]; then echo -ne "$MSG_MISSING$APACHEDOCROOT/$GSSNAME\n" >&2; exit $EXIT_ERR; fi

# Find and delete any old tempfile

$FIND $APACHEDOCROOT/$GSSNAME -name "$TEMPFILEMASK" -type f -cmin +$OLDTIME -user $APACHEADMIN \
      -printf "$MSG_DELETED %c %P\n" -exec $RM -f {} \; 

# Finished
